/*
 * jQuery throttle / debounce - v1.1 - 3/7/2010
 * http://benalman.com/projects/jquery-throttle-debounce-plugin/
 *
 * Copyright (c) 2010 "Cowboy" Ben Alman
 * Dual licensed under the MIT and GPL licenses.
 * http://benalman.com/about/license/
 */
(function(b,c){var $=b.jQuery||b.Cowboy||(b.Cowboy={}),a;$.throttle=a=function(e,f,j,i){var h,d=0;if(typeof f!=="boolean"){i=j;j=f;f=c}function g(){var o=this,m=+new Date()-d,n=arguments;function l(){d=+new Date();j.apply(o,n)}function k(){h=c}if(i&&!h){l()}h&&clearTimeout(h);if(i===c&&m>e){l()}else{if(f!==true){h=setTimeout(i?k:l,i===c?e-m:e)}}}if($.guid){g.guid=j.guid=j.guid||$.guid++}return g};$.debounce=function(d,e,f){return f===c?a(d,e,false):a(d,f,e!==false)}})(this);

var CommentsListViewModel = function(id) {
	var self   = this,
		pusher = 'undefined' !== typeof BAT_WEBSERVICES_PUSHER ? BAT_WEBSERVICES_PUSHER : false,
		audio  = {
			bid: new Howl({ src: [BAT_VMS.bidAudioUrl] }),
			comment: new Howl({ src: [BAT_VMS.commentAudioUrl] }),
		};

	self.id    = ko.observable(id);

	self.order = ko.observable(BAT_VMS.commentOrder);

	self.comments = ko.observableArray();
	self.comments.extend({ rateLimit: { timeout: 50, method: "notifyWhenChangesStop" } });

	self.date = ko.observable(new Date());

	setInterval(function() { self.date(new Date()); }, 1000);

	self.isLoggedIn  = 0 !== parseInt(BAT_VMS.userId) && !isNaN(parseInt(BAT_VMS.userId));
	self.isLoggedOut = !self.isLoggedIn;

	self.isOrderAsc  = ko.computed(function() { return 'asc'  === self.order(); });
	self.isOrderDesc = ko.computed(function() { return 'desc' === self.order(); });

	self.template = function(comment) {
		return 'comment-type-' + comment.type();
	};

	self.addComment = function(data, enableAudio) {
		if(parseInt(data.post) === parseInt(self.id())) {
			var existing = ko.utils.arrayFirst(self.comments(), function(comment) { return data.id == comment.id(); }),
				comment  = new CommentViewModel(data);

			if(existing) {
				existing.update(data);
			} else {
				self.comments.push(comment);

				if(true === enableAudio) {
					if('bat-bid' === data.type && 'on' === BAT_VMS.bidAudioStatus && audio.bid) {
						audio.bid.play();
					}

					if(('' === data.type || 'comment' === data.type) && 'on' === BAT_VMS.commentAudioStatus && audio.comment) {
						audio.comment.play();
					}
				}

				if(pusher && data.channels) {
					for(var i = 0; i < data.channels.length; i++) {
						pusher.subscribe(data.channels[i]);
					}
				}

				if(!self.disableSorting) {
					self.sortComments();
				}
			}
		}
	};

	self.getCommentsByAuthor = function(authorId) {
		return ko.utils.arrayFilter(self.comments(), function(comment) {
			return authorId === parseInt(comment.authorId());
		});
	}

	self.getCommentById = function(commentId) {
		return ko.utils.arrayFirst(self.comments(), function(comment) {
			return commentId === parseInt(comment.id());
		});
	};

	self.removeCommentById = function(commentId) {
		var existing = self.getCommentById(commentId);

		if(existing) {
			self.comments.remove(existing);
		}
	};

	self.disableSorting = false;
	self.sortComments = function() {
		self.comments.sort(function(comment1, comment2) {
			if(self.isOrderDesc()) {
				return comment1.date() < comment2.date() ? 1 : -1;
			} else if(self.isOrderAsc()) {
				return comment1.date() > comment2.date() ? 1 : -1;
			}
		});
	};

	self.slideInActive         = true;
	self.slideInActivePrevious = self.slideInActive;

	// Animate
	self.slideInComment = function(element, index, data) {
		if(false === self.slideInActive) { return; }


		jQuery(element)
			.hide()
			.css('opacity', 0)
			.slideDown();
		jQuery(element).animate({opacity: 1});
	};

	self.loadCommentsText   = ko.observable(BAT_VMS.messageLoadMoreComments);
	self.loadCommentsActive = ko.observable(true);
	self.loadComments       = function() {
		if(self.loadCommentsActive()) {
			self.loadCommentsActive(false);

			self.slideInActivePrevious = self.slideInActive;
			self.slideInActive         = false;

			BAT_VMS.loadCommentsIncrementally(parseInt(BAT_VMS.incrementalLoadCount), true);
		}
	};
};

var CommentViewModel = function(comment) {
	var self = this;

	self.approved             = ko.observable(1 === parseInt(comment.approved));

	self.authorId             = ko.observable(parseInt(comment.authorId));
	self.authorLikes          = ko.observable(comment.authorLikes);
	self.authorLikesFormatted = ko.observable(comment.authorLikesFormatted);
	self.authorName           = ko.observable(comment.authorName);
	self.authorUrl            = ko.observable(comment.authorUrl);
	self.isSeller             = 'bat-listing' == BaT_Theme.type && parseInt(BAT_VMS.postAuthor) == parseInt(comment.authorId);

	self.date          = ko.observable(new Date(parseInt(comment.timestamp) * 1000));
	self.dateFormatted = ko.computed(function() {
		var dateC  = self.date(),
			dateN  = new Date(),
			format = dateC.getFullYear() === dateN.getFullYear() ? 'MMM D [at] h:mm A' : 'M/D/YY [at] h:mm A';

		return moment(dateC).format(format);
	});

	self.dislikes = ko.observable(comment.dislikes);

	self.editableText = ko.observable(comment.editableText);

	self.id = ko.observable(parseInt(comment.id));

	self.likers         = ko.observableArray(comment.likers);
	self.likes          = ko.observable(comment.likes);
	self.likesFormatted = ko.observable(comment.likesFormatted);

	self.flagged = ko.observable(false);

	self.loggedOutLink  = ko.observable(comment.loggedOutLink);

	self.markup = ko.observable(comment.markup);

	self.type = ko.observable(comment.type);

	self.unratable    = ko.observable(comment.unratable);
	self.notUnratable = ko.computed(function() { return !self.unratable(); });

	self.unflaggable    = ko.observable(comment.unflaggable);
	self.notUnflaggable = ko.computed(function() { return !self.unflaggable(); });

	// Featured
	self.isFeatured         = ko.observable(comment.featured);
	self.featuredText       = ko.computed(function() { return self.isFeatured() ? BaT_Theme.featuredTextY : BaT_Theme.featuredTextN });
	self.showFeaturedToggle = ko.computed(function() { return moment(new Date()).format('YYYY-MM-DD') === moment(self.date()).format('YYYY-MM-DD'); });

	// Computed
	self.isHighlighted = ko.computed(function() { return parseInt(BAT_VMS.highlightThreshold) > 0 && parseInt(self.likes()) >= parseInt(BAT_VMS.highlightThreshold) && parseInt(self.dislikes()) < parseInt(BAT_VMS.dislikeThreshold); });
	self.isPending     = ko.computed(function() { return 1 != self.approved(); });
	self.isEditable    = ko.computed(function() { return BAT_VMS.userId == self.authorId() && ((BAT_VMS.CLVM.date() - self.date()) / 1000) < parseInt(BAT_VMS.editableSeconds); });

	self.isFinalizingEditing = ko.observable(false);
	self.isEditing           = ko.observable(false);
	self.isNotEditing        = ko.computed(function() { return !self.isEditing() && !self.isFinalizingEditing(); });

	self.hasRated    = ko.computed(function() { return -1 < ko.utils.arrayIndexOf(self.likers(), BAT_VMS.address) || parseInt(BAT_VMS.userId) === parseInt(self.authorId()); });
	self.hasNotRated = ko.computed(function() { return !self.hasRated(); });

	self.hasUser = ko.computed(function() { return self.authorId() > 0; });

	self.ratable = ko.computed(function() { return self.notUnratable() && !self.isPending(); });

	self.authorLinkTemplate = ko.computed(function() {
		return self.authorUrl() ? 'comment-author-link' : 'comment-author-name';
	});

	self.cancelEditing = function() {
		self.isEditing(false);
	};

	self.initiateEditing = function() {
		self.isEditing(true);
	};

	self.finalizeEditing = function() {
		self.isEditing(false);
		self.isFinalizingEditing(true);

		jQuery.post(
			BaT_Theme.ajaxUrl,
			{
				action: BaT_Theme.ajaxActionCommentEditHandle,
				id:     self.id(),
				text:   self.editableText()
			},
			function(data, status) {
				if(data.error) {
					alert(data.message);

					self.isFinalizingEditing(false);
				}
			},
			'json'
		);
	};

	self.initiateFeature = function() {
		self.isFeatured(!self.isFeatured());

		jQuery.post(
			BaT_Theme.ajaxUrl,
			{
				action: BaT_Theme.ajaxActionCommentFeature,
				id:     self.id()
			},
			function(data, status) {

			},
			'json'
		);
	};

	self.initiateFlag = function() {
		self.flagged(true);

		self.likers.push(BAT_VMS.address);

		ckratingKarma(self.id(), 'subtract');
	};

	self.initiateLike = function() {
		self.likers.push(BAT_VMS.address);

		ckratingKarma(self.id(), 'add');
	};

	self.update = function(comment) {
		self.approved(1 === parseInt(comment.approved));

		self.authorId(parseInt(comment.authorId));
		self.authorLikes(comment.authorLikes);
		self.authorLikesFormatted(comment.authorLikesFormatted);
		self.authorName(comment.authorName);
		self.authorUrl(comment.authorUrl);

		self.date(new Date(parseInt(comment.timestamp) * 1000));

		self.id(parseInt(comment.id));

		self.dislikes(comment.dislikes);
		self.likers(comment.likers);
		self.likes(comment.likes);
		self.likesFormatted(comment.likesFormatted);

		self.isFeatured(comment.featured);

		self.loggedOutLink(comment.loggedOutLink);

		self.markup(comment.markup);

		self.type(comment.type);

		self.unratable(comment.unratable);

		self.unflaggable(comment.unflaggable);

		if(!self.isEditing()) {
			self.editableText(comment.editableText);
		}

		if(self.isFinalizingEditing()) {
			self.isFinalizingEditing(false);
		}
	};
};

BAT_VMS.commentsInitialLoad     = parseInt(BAT_VMS.commentsInitialLoad);
BAT_VMS.commentsLoadingInterval = 1000;
BAT_VMS.lastCommentLoadedIndex  = 'desc' === BAT_VMS.commentOrder ? BAT_VMS.comments.length - 1 : 0;
BAT_VMS.lastCommentLoaded       = false;

BAT_VMS.loadCommentsIncrementally = function(increment, immediately) {
	if(!BAT_VMS.lastCommentLoaded) {
		var $loading = jQuery('#comments-loading');

		$loading.show();

		BAT_VMS.CLVM.slideInActive = false;

		var loader = (function() {
			var indexStart = BAT_VMS.lastCommentLoadedIndex,
				indexAdjustment = ('desc' === BAT_VMS.commentOrder ? -1 : 1),
				indexEnd,
				index;

			// Calculate indexEnd, excluding bids
			var commentsEncountered = 0;

			if('desc' === BAT_VMS.commentOrder) {
				for (indexEnd = indexStart; indexEnd > -1 && commentsEncountered < increment; indexEnd += indexAdjustment) {
					var comment = BAT_VMS.comments[indexEnd];

					if ('comment' === comment.type) {
						commentsEncountered += 1;
					}
				}
			} else {
				for (indexEnd = indexStart; indexEnd < BAT_VMS.comments.length && commentsEncountered < increment; indexEnd += indexAdjustment) {
					var comment = BAT_VMS.comments[indexEnd];

					if('comment' === comment.type) {
						commentsEncountered += 1;
					}
				}
			}

			BAT_VMS.CLVM.disableSorting = true;
			for (index = indexStart; 'desc' === BAT_VMS.commentOrder ? (index > indexEnd) : (index < indexEnd); index += indexAdjustment) {
				BAT_VMS.CLVM.addComment(BAT_VMS.comments[index]);
			}

			BAT_VMS.CLVM.disableSorting = false;
			BAT_VMS.CLVM.sortComments();

			if(('desc' === BAT_VMS.commentOrder && -1 == indexEnd) || ('asc' === BAT_VMS.commentOrder && (indexEnd) === BAT_VMS.comments.length)) {
				BAT_VMS.lastCommentLoaded = true;
			} else {
				BAT_VMS.lastCommentLoadedIndex = indexEnd;
			}

			setTimeout(function() {
				// Hide the loading indicator
				$loading.hide();

				// Restore the ability to load more comments, if necessary
				BAT_VMS.CLVM.loadCommentsActive(false === BAT_VMS.lastCommentLoaded);

				// Restore the previous slide in active setting
				BAT_VMS.CLVM.slideInActive = BAT_VMS.CLVM.slideInActivePrevious;
			}, 150);
		});

		if(immediately) {
			loader();
		} else {
			setTimeout(loader, 100);
		}
	}
};

jQuery(document).ready(function($) {
	var handleBatPaymentOptionUpdate = function() {
		var $checkbox = $('.bat-payment-info .bat-payment-option input'),
			$form = $checkbox.closest('form');

		if($checkbox.is(':checked')) {
			$('.bat-payment-info').addClass('show');
			$form.addClass('bat-listings-form-stripe-v3-setup-card-without-payment');
			$form.find('.control-group-input-optional-required').find('input, select').attr('required', true);
		} else {
			$('.bat-payment-info').removeClass('show');
			$('.bat-payment-info #referral_descriptor').hide();
			$('#bat-listings-users-referral_source').val('');
			$form.removeClass('bat-listings-form-stripe-v3-setup-card-without-payment');
			$form.find('.control-group-input-optional-required').find('input, select').attr('required', false);
		}
	};

	$('.bat-payment-info .bat-payment-option input').click(handleBatPaymentOptionUpdate);
	handleBatPaymentOptionUpdate();

	// Comment rating
	if('function' === typeof ckratingKarma) {
		var ckratingKarmaOld = ckratingKarma;

		ckratingKarma = function(id, action, callback) {
			$.get(
				BaT_Theme.commentRatingUri,
				{
					caction: action,
					id: id,
					path: true
				},
				function(data, status) {
					var parts = data.split('|'),
						partsId = parts[1],
						partsRating = parts[2],
						partsTotal = parts[5];

					if('function' === typeof callback) {
						callback(partsId, partsRating, partsTotal);
					}
				}
			);
		};
	}

	var $comments = $('#comments');

	// Submit the form via CTRL/CMD + ENTER
	$('#comment').on('keydown', function(event) {
		var $comment = $(this);

		if((event.ctrlKey || event.metaKey) && event.which === 13) {
			$comment.parents('form').submit();
		}
	});

	if($comments.length > 0) {
		$('#comments-javascript-warning').hide();

		BAT_VMS.CLVM = new CommentsListViewModel($comments.data('id'));

		BAT_VMS.loadCommentsIncrementally(BAT_VMS.commentsInitialLoad, true);

		ko.applyBindings(BAT_VMS.CLVM, $comments.get(0));

		$('#comments-javascript-enabled').show();

		setTimeout(function() {
			var matches = document.location.hash.match(/#comment-(\d+)/);

			if(matches && matches[1]) {
				var $comments = $('#comments'),
					$comment  = $('#comment-' + matches[1]);

				if($comment.size()) {
					$('html,body').scrollTop($comment.offset().top);
				} else {
					$('html,body').scrollTop($comments.offset().top);
				}
			}
		}, 10);
	}
});
